<h1>Pipes no tan comunes</h1>
<p>
    Pipes incluidos en Angular - Usualmente en el Common Module.
</p>

<div class="grid">
    <!-- <div class="col md-6 sm-9">
        <p-fieldset legend="i18nSelect Pipe" [toggleable]="true" [transitionOptions]="'5ms'">
            <div *ngFor="let item of personas">
                <p>
                    Saludos {{item.nombre}}, es un placer {{item.genero | i18nSelect: invitacionMap}} a nuestro evento.
                </p>
            </div>
        </p-fieldset>
    </div> -->
    <div class="col md-6">
        <p-fieldset legend="i18nSelect Pipe" [toggleable]="true" [transitionOptions]="'5ms'">
                <p>
                    Saludos {{nombre}}, es un placer {{genero | i18nSelect: invitacionMap}} a nuestro evento.
                </p>
                <button pButton pRipple 
                type="button" 
                label="Cambiar Cliente" 
                class="p-button-rounded p-button-warning" 
                icon="pi pi-user" iconPos="right"
                (click)="cambiarCliente()" 
                ></button>
        </p-fieldset>
    </div>
    <div class="col md-6">
        <p-fieldset legend="i18nPlural Pipe" [toggleable]="true" [transitionOptions]="'2ms'">
            <p>{{ clientes.length | i18nPlural: clientMap}}</p>
            <p-button 
            label="Borrar Cliente"  
            icon="pi pi-trash" 
            iconPos="right" 
            styleClass="p-button-help" 
            (onClick)="borrarCliente()"></p-button>
        </p-fieldset>
    </div>
    <div class="col md-6">
        <p-fieldset legend="Slice Pipe" [toggleable]="true" [transitionOptions]="'5ms'">
                <b>Original</b>
                <pre>{{ clientes }}</pre>
                <b>slice:0:2</b>
                <pre>{{ clientes | slice: 0:2 }}</pre>
                <b>{{nombre}} <span>slice:0:3</span> </b>  "Ejm: Usar cuando nos pidan las 3 primeras letras del nombre"
                <!-- el pipe slice el item en la posicion 2 lo va excluir -->
                <pre>{{ nombre | slice: 0:3 }}</pre>
                <!-- <ul *ngFor="let item of clientes"> {{item}} </ul> -->
        </p-fieldset>
    </div>
    <!-- <div class="col md-6 sm-9"> -->
    <div class="col md-6">
        <p-fieldset legend="keyValue Pipe" [toggleable]="true" [transitionOptions]="'2ms'">
            <ul>
                <li *ngFor="let item of persona | keyvalue">
                    {{item.key | titlecase }} : {{item.value}}
                    <!-- {{item | json}} -->
                </li>
            </ul>
        </p-fieldset>
    </div>
    <div class="col md-6">
        <p-fieldset legend="Json Pipe" [toggleable]="true" [transitionOptions]="'2ms'">
            {{persona | json}} 
            <br>
            {{personas | json}} 
        </p-fieldset>
    </div>
    <div class="col md-6">
        <p-fieldset legend="Async Pipe" [toggleable]="true" [transitionOptions]="'2ms'">
            <pre *ngIf="!(obs02$ | async)">Resolviendo observable</pre>    
            <pre>{{obs02$ | async}}</pre>
            <br>
            <br>
            <pre *ngIf="!(valorPromesa | async)">Resolviendo promesa</pre>    
            <pre>{{valorPromesa | async}}</pre>    
        </p-fieldset>
    </div>

</div>